# -*- coding: utf-8 -*-
import traceback

import utils.common.log as logger
from plugins.DistributedStorage.implement.TC_StorageNode_Config_JBOD import ConfigureDiskJBODMode
from utils.DBAdapter.DBConnector import BaseOps
from utils.common.exception import HCCIException
from utils.common.fic_base import StepBaseInterface
from utils.common.message import Message


class ConfigJBOD(StepBaseInterface):
    def __init__(self, project_id, pod_id):
        super(ConfigJBOD, self).__init__(project_id, pod_id)
        self.project_id = project_id
        self.pod_id = pod_id
        self.db = BaseOps()
        self.bmc_info_list = self.db.get_install_os_list_info(self.pod_id)
        self.fs_args = dict()
        self.fs_args["bmc_info_list"] = self.bmc_info_list
        self.implement = ConfigureDiskJBODMode(self.project_id, self.pod_id, self.fs_args)

    def pre_check(self, project_id, pod_id):
        """
        插件内部接口：执行安装前的资源预检查，该接口由execute接口调用，工具框架不会直接调用此接口。
        :param project_id:
        :param pod_id:
        :return:
        """
        pass

    def execute(self, project_id, pod_id):
        try:
            self.implement.procedure()
        except HCCIException as e1:
            logger.error(traceback.format_exc())
            return Message(500, e1)
        except Exception as e2:
            logger.error(str(e2))
            return Message(500, HCCIException('626038', str(e2)))
        return Message(200)

    def rollback(self, project_id, pod_id):
        """
        标准调用接口：执行回滚
        :param project_id:
        :param pod_id:
        :return:Message类对象
        """
        return Message(200)

    def retry(self, project_id, pod_id):
        """
        标准调用接口：重试
        :return: Message类对象
        """
        return self.execute(project_id, pod_id)

    def check(self, project_id, pod_id):
        """
        标准调用接口：重试
        :param project_id:
        :param pod_id:
        :return:
        """
        pass
